using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SetupGrid;

namespace Main
{
    public partial class MainFrm : Form
    {
        #region [Constant(s)]
        private const string btnStartTxt = "Setup";
        private const string btnStopTxt = "Stop";
        #endregion

        #region [ Constructor(s) ]
        public MainFrm()
        {
            InitializeComponent();
        } 
        #endregion

        #region [ Private Methods(s) ]
        private void btnSetup_Click(object sender, EventArgs e)
        {
            if (stpGrid.InProgress)
                stpGrid.StopSetup(false);
            else
                stpGrid.StartSetup();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            setupDS.WriteXml(SetupGridUC.SetupScriptsXml);
        }

        private void stpGrid_ProgressFinished(object sender, EventArgs e)
        {
            btnSetup.Text = btnStartTxt;
            btnReload.Enabled = true;
        }

        private void stpGrid_ProgressStarted(object sender, EventArgs e)
        {
            btnSetup.Text = btnStopTxt;
            btnReload.Enabled = false;
        }

        private void MainFrm_FormClosing(object sender, FormClosingEventArgs e)
        {
            stpGrid.StopSetup(false);
        }

        private void MainFrm_Load(object sender, EventArgs e)
        {
            stpGrid.Load();
            setupDS.Clear();
            setupDS.Merge(stpGrid.DataSet);

        }

        private void btReload_Click(object sender, EventArgs e)
        {
            stpGrid.Load();
        } 
        #endregion
    }
}