using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace SetupGrid.ScriptCommands
{
    #region [ Public Delegate(s) ]
    public delegate void ProgressDelegate(int indicator);
    public delegate bool HaltDelegate();
    #endregion

    public class MethodCommand : BaseCommand
    {
        #region [ Constructor(s) ]
        public MethodCommand(SetupGrid.Properties.SetupDS.tblSetupScriptsRow script, ISetupGridUC ctrl)
            : base(script, ctrl)
        {
        } 
        #endregion

        #region [ Public Method(s) ]
        public void DoProgress(int indicator)
        {
            OnProgress(this, new ProgressEventArgs(indicator));
        }

        public bool DoHalt()
        {
            return this.SetupGridUC.HaltSetup;
        } 
        #endregion

        #region [ Overrided Method(s) ]
        public override void Execute()
        {
            /// D:\Ansari\dot.Net\SetupGrid\Main\bin\Debug\SetupGrid.dll,
            /// SetupGrid.Scripts.MethodsClass,Sleep
            string[] scripts = this.Script.Script.Split(',');
            string assemblyFile = scripts[0];
            string typeName = scripts[1];
            string method = scripts[2];

            Assembly assembly = Assembly.LoadFrom(assemblyFile);
            Type hostType = assembly.GetType(typeName);
            object hostObject = Activator.CreateInstance(hostType);
            MethodInfo theMethods = hostType.GetMethod(method,
                new Type[2] { typeof(ProgressDelegate), typeof(HaltDelegate) });

            theMethods.Invoke(hostObject, new object[2] { (ProgressDelegate)DoProgress, (HaltDelegate)DoHalt });
        }

        public override ScriptKind Kind
        {
            get { return ScriptKind.Method; }
        } 
        #endregion
    }
}
