using System;
using System.Collections.Generic;
using System.Text;

namespace SetupGrid.Scripts
{
    public class MethodsClass
    {
        #region [ Public Method(s) being called from Setup Grid using Refelecation ]
        /// <summary>
        ///     This method will be called using reflection. It is defined in SetupScripts.xml file. The developer should
        ///     pass following two delegate parameters to it that are doing some actions on calling SetupGrid object.
        /// </summary>
        /// <param name="doProgress"> This method sets progress bar status in the subject row of the SetupGrid  </param>
        /// <param name="doHalt"> This method returns true if user stops the setup process </param>
        public void Sleep(SetupGrid.ScriptCommands.ProgressDelegate doProgress, SetupGrid.ScriptCommands.HaltDelegate doHalt)
        {
            for (int i = 0; i <= 25; i++)
            {
                if (doHalt())
                    return;
                Random rnd = new Random();
                System.Threading.Thread.Sleep(rnd.Next(1, 100));
                doProgress(i * 4);
            }
        } 
        #endregion
    }
}
